/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * This class provides services to render a map into an image
 *
 */
 public class MgdRenderingService extends MgService {
  private long swigCPtr;

  public MgdRenderingService(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgdRenderingServiceToMgService(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected MgdRenderingService() {
    this(0, false);
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgdRenderingService(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgdRenderingService obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Returns the specified base map tile for the given map.
 *
 * @param  map  Input  map object containing current state of map.
 * @param  baseMapLayerGroupName  Input  Specifies the name of the baseMapLayerGroup for which to render the tile.
 * @param  tileColumn  Input  Specifies the column index of the tile to return.
 * @param  tileRow  Input  Specifies the row index of the tile to return.
 * @return  A byte reader containing the rendered tile image.
 */
 public MgByteReader renderTile(MgdMap map, String baseMapLayerGroupName, int tileColumn, int tileRow) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_RenderTile(swigCPtr, MgdMap.getCPtr(map), baseMapLayerGroupName, tileColumn, tileRow);
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Renders all dynamic layers in the specified {@link MgdMap} to a dynamic overlay image
 * with a transparent background. The center, scale, size, and layers to be
 * rendered are defined by the specified map instance.  The format parameter
 * must be set to an image format that supports transparency.
 *
 * @param  map  Input  map object containing current state of map.
 * @param  selection  Input  map feature selection. Specifies the selected features on the map
 * @param  format  Input  image format. Defines the format of the resulting image
 * @return  A byte reader containing the rendered image
 */
 public MgByteReader renderDynamicOverlay(MgdMap map, MgdSelection selection, String format) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_RenderDynamicOverlay__SWIG_0(swigCPtr, MgdMap.getCPtr(map), MgdSelection.getCPtr(selection), format);
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Renders all dynamic layers in the specified {@link MgdMap} to a dynamic overlay image
 * with a transparent background. The center, scale, size, and layers to be
 * rendered are defined by the specified map instance.  The format parameter
 * must be set to an image format that supports transparency.
 *
 * @param  map  Input  map object containing current state of map.
 * @param  selection  Input  map feature selection. Specifies the selected features on the map
 * @param  format  Input  image format. Defines the format of the resulting image
 * @param  bKeepSelection  Input  true if you want to keep the selection
 * @return  A byte reader containing the rendered image
 */
 public MgByteReader renderDynamicOverlay(MgdMap map, MgdSelection selection, String format, boolean bKeepSelection) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_RenderDynamicOverlay__SWIG_1(swigCPtr, MgdMap.getCPtr(map), MgdSelection.getCPtr(selection), format, bKeepSelection);
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Renders all dynamic layers in the specified {@link MgdMap} to a dynamic overlay image
 * with a transparent background. The center, scale, size, and layers to be
 * rendered are defined by the specified map instance.  The format parameter
 * must be set to an image format that supports transparency.
 *
 * @param  map  Input  map object containing current state of map.
 * @param  selection  Input  map feature selection. Specifies the selected features on the map
 * @param  options  Input  rendering options
 * @return  A byte reader containing the rendered image
 */
 public MgByteReader renderDynamicOverlay(MgdMap map, MgdSelection selection, MgdRenderingOptions options) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_RenderDynamicOverlay__SWIG_2(swigCPtr, MgdMap.getCPtr(map), MgdSelection.getCPtr(selection), MgdRenderingOptions.getCPtr(options));
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Renders the specified {@link MgdMap} to the requested image format.
 *
 * @param  map  Input  map object containing current state of map.
 * @param  selection  Input  map feature selection. Specifies the selected features on the map
 * @param  format  Input  image format. Defines the format of the resulting image
 * @return  A byte reader containing the rendered image
 */
 public MgByteReader renderMap(MgdMap map, MgdSelection selection, String format) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_RenderMap__SWIG_0(swigCPtr, MgdMap.getCPtr(map), MgdSelection.getCPtr(selection), format);
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Renders the specified {@link MgdMap} to the requested image format.
 *
 * @param  map  Input  map object containing current state of map.
 * @param  selection  Input  map feature selection. Specifies the selected features on the map
 * @param  format  Input  image format. Defines the format of the resulting image
 * @param  bKeepSelection  Input  true if you want to keep the selection
 * @return  A byte reader containing the rendered image
 */
 public MgByteReader renderMap(MgdMap map, MgdSelection selection, String format, boolean bKeepSelection) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_RenderMap__SWIG_1(swigCPtr, MgdMap.getCPtr(map), MgdSelection.getCPtr(selection), format, bKeepSelection);
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Renders the specified {@link MgdMap} to the requested image format.
 *
 * @param  map  Input  map object containing current state of map.
 * @param  selection  Input  map feature selection. Specifies the selected features on the map
 * @param  format  Input  image format. Defines the format of the resulting image
 * @param  bKeepSelection  Input  true if you want to keep the selection
 * @param  bClip  Input  true if you want to clip feature geometry
 * @return  A byte reader containing the rendered image
 */
 public MgByteReader renderMap(MgdMap map, MgdSelection selection, String format, boolean bKeepSelection, boolean bClip) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_RenderMap__SWIG_2(swigCPtr, MgdMap.getCPtr(map), MgdSelection.getCPtr(selection), format, bKeepSelection, bClip);
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Renders the legend for the specified {@link MgdMap} to the requested size and format
 *
 * @param  map  Input  map object containing current state of map.
 * @param  width  Input  width of legend image in pixels
 * @param  height  Input  height of legend image in pixels
 * @param  backgroundColor  Input  background color. Specifies the map legend background color
 * @param  format  Input  image format. Defines the format of the resulting image
 * @return  A byte reader containing the rendered image
 */
 public MgByteReader renderMapLegend(MgdMap map, int width, int height, MgColor backgroundColor, String format) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_RenderMapLegend(swigCPtr, MgdMap.getCPtr(map), width, height, MgColor.getCPtr(backgroundColor), format);
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * The QueryFeatures operation identifies those features that
 * meet the specified spatial selection criteria. This operation
 * is used to implement server-side selection. In addition to
 * a selection set, this operation returns attribute information
 * in case only one feature is selected
 *
 * @param  map  Input  map object containing current state of map.
 * @param  layerNames  Input  Active layer names for which to query features
 * @param  filterGeometry  Input  geometry object specifying the selection area
 * @param  selectionVariant  Input  selection criterion - integer value corresponding to one of  the {@link MgFeatureSpatialOperations} values
 * @param  maxFeatures  Input  the maximum number of features to return
 * @return  An {@link MgSelection} instance identifying the features that meet the
 *  selection criteria. Returns null if no features are identified.
 */
 public MgdFeatureInformation queryFeatures(MgdMap map, MgStringCollection layerNames, MgGeometry filterGeometry, int selectionVariant, int maxFeatures) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_QueryFeatures__SWIG_0(swigCPtr, MgdMap.getCPtr(map), MgStringCollection.getCPtr(layerNames), MgGeometry.getCPtr(filterGeometry), selectionVariant, maxFeatures);
    return (cPtr == 0) ? null : (MgdFeatureInformation)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * The QueryFeatures operation identifies those features that
 * meet the specified spatial selection criteria. This operation
 * is used to implement server-side selection. In addition to
 * a selection set, this operation returns attribute information
 * in case only one feature is selected
 *
 * @param  map  Input  map object containing current state of map.
 * @param  layerNames  Input  Active layer names for which to query features
 * @param  filterGeometry  Input  geometry object specifying the selection area
 * @param  selectionVariant  Input  selection criterion - integer value corresponding to one of  the {@link MgFeatureSpatialOperations} values
 * @param  featureFilter  Input  an XML selection string containing the required feature IDs
 * @param  maxFeatures  Input  the maximum number of features to return
 * @param  layerAttributeFilter  Input  bitmask values - 1=Visible, 2=Selectable, 4=HasTooltips
 * @return  An {@link MgSelection} instance identifying the features that meet the
 *  selection criteria. Returns null if no features are identified.
 */
 public MgdFeatureInformation queryFeatures(MgdMap map, MgStringCollection layerNames, MgGeometry filterGeometry, int selectionVariant, String featureFilter, int maxFeatures, int layerAttributeFilter) {
    long cPtr = MapGuideDesktopApiJNI.MgdRenderingService_QueryFeatures__SWIG_1(swigCPtr, MgdMap.getCPtr(map), MgStringCollection.getCPtr(layerNames), MgGeometry.getCPtr(filterGeometry), selectionVariant, featureFilter, maxFeatures, layerAttributeFilter);
    return (cPtr == 0) ? null : (MgdFeatureInformation)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

}
